Evil

- Main Page
- Related Pages
- Modules
- Data Structures
- Files
- Examples

Modules | Functions
Evil

Microsoft Windows portability layer. More...

## Modules
| Functions that manage dynamic-link libraries.
| This header provides functions to load and unload dynamic-link libaries, to get the address of a symbol, and to get diagnostic information.
| locale.h functions.
| This header provides functions ported from Unix in locale.h.
| Main
| This header provides functions to initialize and shut down the Evil library.
| Functions that manage memory mappping.
| This header provides the meomry map functions mmap and munmap.
| Stdio.h functions
| This header provides functions ported from Unix in stdio.h.
| Stdlib.h functions.
| This header provides functions ported from Unix in stdlib.h.
| String.h functions.
| This header provides functions ported from Unix in string.h.
| Time.h functions
| This header provides functions ported from Unix in time.h.
| Unistd.h functions
| This header provides functions ported from Unix in unistd.h.

## Functions
EVIL_API int | fcntl (int fd, int cmd,...)
| Provide control over file descriptors.
EVIL_API wchar_t * | evil_char_to_wchar (const char *text)
| Convert a string from char * to wchar_t *.
EVIL_API char * | evil_wchar_to_char (const wchar_t *text)
| Convert a string from wchar_t * to char *.
EVIL_API char * | evil_utf16_to_utf8 (const wchar_t *text)
| Convert a string from UTF-16 to UTF-8.
EVIL_API wchar_t * | evil_utf8_to_utf16 (const char *text)
| Convert a string from UTF-8 to UTF-16.
EVIL_API int | evil_path_is_absolute (const char *path)
| check if the given path is absolute.

## Detailed Description

Microsoft Windows portability layer.

## Function Documentation

## ◆ fcntl()

EVIL_API int fcntl | ( | int | fd,
|  | int | cmd,
|  |  | ...
| ) |  |

Provide control over file descriptors.

Parameters

  fd | The file descriptor.
  cmd | The type of control.

Returns
  0 on success, -1 otherwise.

Performs one of various miscellaneous operations on `fd`. The operation in question is determined by `cmd:`

- F_SETFD: Set the close-on-exec flag to the value specified by the argument after command (only the least significant bit is used).
- F_SETLK and F_SETLKW: used to manage discretionary file locks. The third argument must be a pointer to a struct flock (that may be overwritten by this call).

This function returns 0 on success, -1 otherwise.

Conformity: None.

Supported OS: Windows Vista, Windows XP or Windows 2000 Professional.

References flock::l_len, flock::l_start, flock::l_type, and flock::l_whence.

Referenced by ecore_pipe_full_add(), eeze_mount_tabs_watch(), eina_debug_local_connect(), eina_debug_remote_connect(), and eina_file_close_on_exec().

## ◆ evil_char_to_wchar()

EVIL_API wchar_t * evil_char_to_wchar | ( | const char * | text | ) |

Convert a string from char * to wchar_t *.

Parameters

  text | The string to convert.

Returns
  The converted string.

Convert a string from char * to wchar_t * and return it. If the allocation or conversion fails, NULL is returned. On success, the returned value must be freed when it is not used anymore.

Conformity: Non applicable.

Supported OS: Windows 95, Windows 98, Windows Me, Windows NT, Windows 2000, Windows XP.

Referenced by dlopen(), and dlsym().

## ◆ evil_wchar_to_char()

EVIL_API char * evil_wchar_to_char | ( | const wchar_t * | text | ) |

Convert a string from wchar_t * to char *.

Parameters

  text | The string to convert.

Returns
  The converted string.

Convert a string from wchar_t * to char * and return it. If the allocation or conversion fails, NULL is returned. On success, the returned value must be freed when it is not used anymore.

Conformity: Non applicable.

Supported OS: Windows 95, Windows 98, Windows Me, Windows NT, Windows 2000, Windows XP.

Referenced by eina_file_dir_list().

## ◆ evil_utf16_to_utf8()

EVIL_API char * evil_utf16_to_utf8 | ( | const wchar_t * | text | ) |

Convert a string from UTF-16 to UTF-8.

Parameters

  text | The string to convert in UTF-16.

Returns
  The converted string in UTF-8.

Convert a string from UTF-16 to UTF-8 and return it. If the allocation or conversion fails, NULL is returned. On success, the returned value must be freed when it is not used anymore.

Conformity: Non applicable.

Supported OS: Windows 95, Windows 98, Windows Me, Windows NT, Windows 2000, Windows XP.

Referenced by ecore_win32_clipboard_get(), and efreet_uri_decode().

## ◆ evil_utf8_to_utf16()

EVIL_API wchar_t * evil_utf8_to_utf16 | ( | const char * | text | ) |

Convert a string from UTF-8 to UTF-16.

Parameters

  text | The string to convert in UTF-8.

Returns
  The converted string in UTF-16.

Convert a string from UTF-8 to UTF-16 and return it. If the allocation or conversion fails, NULL is returned. On success, the returned value must be freed when it is not used anymore.

Conformity: Non applicable.

Since
  1.24

Referenced by ecore_win32_clipboard_set(), and efreet_uri_decode().

## ◆ evil_path_is_absolute()

EVIL_API int evil_path_is_absolute | ( | const char * | path | ) |

check if the given path is absolute.

Parameters

  path | The path to check.

Returns
  1 if the given path is absolute, 0 otherwise.

Check if the path `path` is absolute or not. An absolute path must begin with a letter (upper or lower case), followed by by the char ':', followed by the char '/' or '\'. If `path` is absolute this function returns 1, otherwise it returns 0. If `path` is `NULL`, it returns 0.

Conformity: Non applicable.

Supported OS: Windows 95, Windows 98, Windows Me, Windows NT, Windows 2000, Windows XP.

Since
  1.7

Referenced by eina_file_path_relative(), and elm_prefs_file_set().